代码随想录算法训练营第二十一天|LeetCode530、LeetCode501、LeetCode236

LeetCode530

题目:

 解法:

class Solution {
public:
    vector<int> vec;
    int min = 100000;
    void get(TreeNode* node){
        if(node == NULL) return;
        if(node -> left) get(node -> left);
        if(vec.size() >= 1 && min > abs(node ->val - vec.back())) min = abs(node ->val - vec.back());
        vec.push_back(node -> val);
        
        if(node -> right) get(node -> right);
    }
    int getMinimumDifference(TreeNode* root) {
         get(root);
         return min;
    }
};

LeetCode 501

题目:

 解法1:(通用解法)

class Solution {
public:
    void findmuch(TreeNode* node,unordered_map<int,int> &map){
        if(node == NULL) return;
        map[node -> val]++;
        findmuch(node -> left,map);
        findmuch(node -> right,map);
        return;  
    }
    bool static cmp(const pair<int,int> &a,pair<int,int> &b){
        return a.second > b.second;
    }    
    vector<int> findMode(TreeNode* root) {
        unordered_map<int,int> mp;
        vector<int> result;
        if(root == NULL) return result;
        findmuch(root, mp);
        vector<pair<int,int>> vec(mp.begin(),mp.end());
        sort(vec.begin(),vec.end(),cmp);
        result.push_back(vec[0].first);
        for(int i = 1 ; i < vec.size(); i++){
            if(vec[i].second == vec[0].second){
                result.push_back(vec[i].first);
            }
        }
        return result;
    }
};

解法2:(双指针)

class Solution {
public: 
    vector<int> result;
    int count = 0;
    TreeNode* pre = NULL;
    int MAX = 0;
    void findmuch(TreeNode* node){
        if(node == NULL) return;
        if(node -> left) findmuch(node ->left);
        if(pre == NULL) count = 1;
        else if(pre->val == node ->val) count ++;
        else count = 1;
        pre = node;
        if(count == MAX) result.push_back(node -> val);
        if(count > MAX ){
            MAX = count;
            result.clear();
            result.push_back(node -> val);
        }
        if(node -> right) findmuch(node ->right);
        return;
    }

    vector<int> findMode(TreeNode* root) {
       findmuch(root);
       return result;
    }
};

LeetCode236:

题目:

 解法1:(返回bool)

class Solution {
public:
    TreeNode* common = NULL;
    bool findcommon(TreeNode* node,TreeNode* p, TreeNode* q){
        bool leftb = false,rightb = false,nodeb = false;
        if(node -> left)  leftb = findcommon(node ->left,p,q);
        if(node -> right)  rightb = findcommon(node ->right,p,q);
        if(node == p) nodeb = true;
        if(node == q) nodeb = true;
        if((!nodeb && rightb && !leftb) ||(!nodeb && leftb && !rightb)) return true;
        if((leftb && rightb)|| (leftb && nodeb) ||(rightb && nodeb)) common = node;
        return nodeb;
    }
    TreeNode* lowestCommonAncestor(TreeNode* root, TreeNode* p, TreeNode* q) {
        bool nodeb = findcommon(root, p, q);
        return common;
    }
};

解法2:(返回节点) 

class Solution {
public:
    
    TreeNode* lowestCommonAncestor(TreeNode* root, TreeNode* p, TreeNode* q) {
        TreeNode* nodeleft = NULL;
        TreeNode* noderight = NULL;
        if(root -> left) nodeleft = lowestCommonAncestor(root ->left, p, q);
        if(root -> right) noderight = lowestCommonAncestor(root ->right, p, q);
        if(root == NULL || root == p || root == q) return root;
        if(nodeleft && noderight) return root;
        if(nodeleft && !noderight) return nodeleft;
        if(!nodeleft && noderight) return noderight;
        return NULL;       
    }
};

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
第二十二算法训练营主要涵盖了Leetcode题目中的三道题目,分别是Leetcode 28 "Find the Index of the First Occurrence in a String",Leetcode 977 "有序数组的平方",和Leetcode 209 "长度最小的子数组"。 首先是Leetcode 28题,题目要求在给定的字符串中找到第一个出现的字符的索引。思路是使用双指针来遍历字符串,一个指向字符串的开头,另一个指向字符串的结尾。通过比较两个指针所指向的字符是否相等来判断是否找到了第一个出现的字符。具体实现的代码如下: ```python def findIndex(self, s: str) -> int: left = 0 right = len(s) - 1 while left <= right: if s[left == s[right]: return left left += 1 right -= 1 return -1 ``` 接下来是Leetcode 977题,题目要求对给定的有序数组中的元素进行平方,并按照非递减的顺序返回结果。这里由于数组已经是有序的,所以可以使用双指针的方法来解决问题。一个指针指向数组的开头,另一个指针指向数组的末尾。通过比较两个指针所指向的元素的绝对值的大小来确定哪个元素的平方应该放在结果数组的末尾。具体实现的代码如下: ```python def sortedSquares(self, nums: List[int]) -> List[int]: left = 0 right = len(nums) - 1 ans = [] while left <= right: if abs(nums[left]) >= abs(nums[right]): ans.append(nums[left ** 2) left += 1 else: ans.append(nums[right ** 2) right -= 1 return ans[::-1] ``` 最后是Leetcode 209题,题目要求在给定的数组中找到长度最小的子数组,

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值